> This is a page from the ElevenLabs documentation. For a complete page index, fetch https://elevenlabs.io/docs/llms.txt. For the full documentation in a single file, fetch https://elevenlabs.io/docs/llms-full.txt. # Create environment variable POST https://api.elevenlabs.io/v1/convai/environment-variables Content-Type: application/json Create a new environment variable for the workspace Reference: https://elevenlabs.io/docs/eleven-agents/api-reference/environment-variables/create ## Servers - `https://api.elevenlabs.io` (Production, default) - `https://api.us.elevenlabs.io` (Production US) - `https://api.eu.residency.elevenlabs.io` (Production EU) - `https://api.in.residency.elevenlabs.io` (Production India) - `https://api.sg.residency.elevenlabs.io` (Production Singapore) ## Request ### Body (application/json) This endpoint expects an EnvironmentVariablesCreateRequestBody. - `EnvironmentVariablesCreateRequestBody` - `type`: `string` - `label` (string, required) — Unique label for the environment variable. - `values` (map from string to string, required) — Environment-specific values. Must include 'production' key. - `type`: `secret` - `label` (string, required) — Unique label for the environment variable. - `values` (map from string to EnvironmentVariableSecretValueRequest, required) — Environment-specific secret references. Must include 'production' key. - `type`: `auth_connection` - `label` (string, required) — Unique label for the environment variable. - `values` (map from string to EnvironmentVariableAuthConnectionValueRequest, required) — Environment-specific auth connection references. Must include 'production' key. ## Response ### 200 Successful Response - `label` (string, required) - `created_at_unix_secs` (integer, required) - `updated_at_unix_secs` (integer, required) - `type` (enum, required) - Allowed values: `string`, `secret`, `auth_connection` - `id` (string, required) - `workspace_id` (string, required) - `values` (EnvironmentVariableResponseValues, required) - `created_by_user_id` (string, optional) ## Errors ### 400 Environment Variables Create Request Bad Request Error Invalid parameters - `any` ### 409 Environment Variables Create Request Conflict Error Environment variable with this label already exists - `any` ### 422 Environment Variables Create Request Unprocessable Entity Error Validation Error - `detail` (list of ValidationError, optional) ## Types ### EnvironmentVariableSecretValueRequest - `secret_id` (string, required) ### EnvironmentVariableAuthConnectionValueRequest - `auth_connection_id` (string, required) ### EnvironmentVariableResponseValues ### ValidationError - `loc` (list of ValidationErrorLocItem, required) - `msg` (string, required) - `type` (string, required) ### ValidationErrorLocItem ## Examples **Request** ```json { "type": "string", "label": "label", "values": { "key": "value" } } ``` **Response** ```json { "label": "label", "created_at_unix_secs": 1, "updated_at_unix_secs": 1, "type": "string", "id": "id", "workspace_id": "workspace_id", "values": { "key": "value" }, "created_by_user_id": "created_by_user_id" } ``` **SDK Code** ```python import requests url = "https://api.elevenlabs.io/v1/convai/environment-variables" payload = { "type": "string", "label": "label", "values": { "key": "value" } } headers = {"Content-Type": "application/json"} response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.elevenlabs.io/v1/convai/environment-variables'; const options = { method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{"type":"string","label":"label","values":{"key":"value"}}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.elevenlabs.io/v1/convai/environment-variables" payload := strings.NewReader("{\n \"type\": \"string\",\n \"label\": \"label\",\n \"values\": {\n \"key\": \"value\"\n }\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.elevenlabs.io/v1/convai/environment-variables") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Content-Type"] = 'application/json' request.body = "{\n \"type\": \"string\",\n \"label\": \"label\",\n \"values\": {\n \"key\": \"value\"\n }\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.elevenlabs.io/v1/convai/environment-variables") .header("Content-Type", "application/json") .body("{\n \"type\": \"string\",\n \"label\": \"label\",\n \"values\": {\n \"key\": \"value\"\n }\n}") .asString(); ``` ```php request('POST', 'https://api.elevenlabs.io/v1/convai/environment-variables', [ 'body' => '{ "type": "string", "label": "label", "values": { "key": "value" } }', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.elevenlabs.io/v1/convai/environment-variables"); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"type\": \"string\",\n \"label\": \"label\",\n \"values\": {\n \"key\": \"value\"\n }\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [ "type": "string", "label": "label", "values": ["key": "value"] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.elevenlabs.io/v1/convai/environment-variables")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` > ElevenLabs provides APIs and SDKs for text to speech, voice cloning, speech to text, sound effects, voice isolator, voice changer, and conversational AI agents. Build voice-enabled applications with lifelike audio generation.